SystemOrganization addCategory: #'Seaside-Tools-OmniBrowser'!
SystemOrganization addCategory: #'Seaside-Tools-OmniBrowser-Commands'!

OBCommand subclass: #WACmdAddAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdAddAdaptor methodsFor: 'accessing' stamp: 'lr 2/7/2009 10:10'!
adaptors
	^ (WAServerAdaptor allSubclasses reject: [ :each | each isAbstract ])
		asSortedCollection: [ :a :b | a name < b name ]! !

!WACmdAddAdaptor methodsFor: 'execution' stamp: 'jf 9/30/2009 01:10'!
execute
	| class port adaptor |
	class := OBChoiceRequest 
		prompt: 'Chose adaptor type'
		labels: (self adaptors collect: [ :each | each name ])
		values: self adaptors.
	class isNil ifTrue: [ ^ self ].
	port := OBTextRequest 
		prompt: 'Enter port number'
		template: class basicNew defaultPort greaseString.
	(port isNil or: [ port isEmpty or: [ port isAllDigits not ] ]) ifTrue: [ ^ self ].
	adaptor := class port: port greaseInteger.
	requestor browser announce: (OBNodeCreated node: adaptor asNode)! !

!WACmdAddAdaptor methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:21'!
group
	^ #changing! !

!WACmdAddAdaptor methodsFor: 'testing' stamp: 'lr 2/16/2009 20:43'!
isActive
	^ (requestor isSelected: target) not! !

!WACmdAddAdaptor methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:21'!
label
	^ 'Add adaptor...'! !

OBCommand subclass: #WACmdAddHandler
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdAddHandler class methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:41'!
instances
	^ WARequestHandler concreteSubclasses collect: [ :each | self new setType: each ]! !

!WACmdAddHandler methodsFor: 'execution' stamp: 'jf 1/30/2009 17:36'!
execute
	| name handler |
	name := OBTextRequest prompt: 'Entry point name:'.
	(name isNil or: [ name isEmpty ]) ifTrue: [ ^ self ].
	handler := WAAdmin register: type at: name in: target handler.
	handler isApplication ifTrue: [ WAAdmin configureNewApplication: handler ].
	requestor browser announce: (OBNodeCreated node: handler asNode)! !

!WACmdAddHandler methodsFor: 'accessing' stamp: 'lr 1/23/2009 08:22'!
group
	^ #adding! !

!WACmdAddHandler methodsFor: 'testing' stamp: 'lr 1/20/2009 19:08'!
isActive
	^ (requestor isSelected: target) and: [ target isHandler and: [ target canHaveChildren ] ]! !

!WACmdAddHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:12'!
label
	^ 'Add ' , self type description! !

!WACmdAddHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:11'!
on: anObject for: aRequestor
	^ (super on: anObject for: aRequestor) setType: self type! !

!WACmdAddHandler methodsFor: 'initialization' stamp: 'lr 1/20/2009 19:11'!
setType: aClass
	type := aClass! !

!WACmdAddHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:11'!
type
	^ type! !

OBCommand subclass: #WACmdBrowseRequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdBrowseRequestHandler methodsFor: 'execution' stamp: 'lr 3/5/2009 21:55'!
execute
	(WAHandlerBrowser metaNode: WAHandlerBrowser adaptorMetaNode node: target copy) open! !

!WACmdBrowseRequestHandler methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:20'!
group
	^ #browsing! !

!WACmdBrowseRequestHandler methodsFor: 'testing' stamp: 'jf 1/7/2009 21:19'!
isActive
	^ requestor isSelected: target! !

!WACmdBrowseRequestHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 18:59'!
keystroke
	^ $b! !

!WACmdBrowseRequestHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:28'!
label
	^ 'Browse'! !

!WACmdBrowseRequestHandler methodsFor: 'testing' stamp: 'lr 8/14/2010 09:23'!
wantsButton
	^ true! !

OBCommand subclass: #WACmdClearConfigurationCaches
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdClearConfigurationCaches methodsFor: 'execution' stamp: 'SK 9/4/2009 18:20'!
execute
	WAAdmin clearConfigurationCaches! !

!WACmdClearConfigurationCaches methodsFor: 'testing' stamp: 'SK 9/4/2009 18:21'!
group
	^ #manager! !

!WACmdClearConfigurationCaches methodsFor: 'testing' stamp: 'SK 9/4/2009 18:21'!
isActive
	^ requestor isSelected: target! !

!WACmdClearConfigurationCaches methodsFor: 'accessing' stamp: 'SK 9/4/2009 18:20'!
label
	^ 'Clear configuration caches'! !

OBCommand subclass: #WACmdClearSessions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdClearSessions methodsFor: 'execution' stamp: 'lr 1/23/2009 08:20'!
execute
	WAAdmin clearSessions! !

!WACmdClearSessions methodsFor: 'testing' stamp: 'MAD 1/20/2009 00:55'!
group
	^ #manager! !

!WACmdClearSessions methodsFor: 'testing' stamp: 'MAD 1/20/2009 00:51'!
isActive
	^ requestor isSelected: target! !

!WACmdClearSessions methodsFor: 'accessing' stamp: 'lr 1/23/2009 08:19'!
label
	^ 'Clear sessions'! !

OBCommand subclass: #WACmdEncodingForAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdEncodingForAdaptor methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:27'!
codecs
	^ GRCodec allCodecs asSortedCollection: [ :a :b | a name < b name ]! !

!WACmdEncodingForAdaptor methodsFor: 'execution' stamp: 'jf 2/7/2009 20:27'!
execute
	| codec |
	codec := OBChoiceRequest
		prompt: 'Select encoding'
		labels: (self codecs 
			collect: [ :each | each name ]) 
		values: self codecs.
	codec isNil
		ifTrue: [ ^ self ].
	target adaptor codec: codec.
	requestor browser signalRefresh! !

!WACmdEncodingForAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 15:23'!
isActive
	^ requestor isSelected: target! !

!WACmdEncodingForAdaptor methodsFor: 'accessing' stamp: 'lr 2/7/2009 10:20'!
label
	^ 'Encoding...'! !

OBCommand subclass: #WACmdInspectAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdInspectAdaptor methodsFor: 'execution' stamp: 'MAD 1/10/2009 17:57'!
execute
	target inspectAdaptor! !

!WACmdInspectAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 15:10'!
isActive
	^ requestor isSelected: target! !

!WACmdInspectAdaptor methodsFor: 'accessing' stamp: 'jf 1/10/2009 23:50'!
keystroke
	^ $i! !

!WACmdInspectAdaptor methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:27'!
label
	^ 'Inspect'! !

OBCommand subclass: #WACmdMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdMode methodsFor: 'testing' stamp: 'lr 1/20/2009 19:28'!
cluster
	^ #Mode! !

!WACmdMode methodsFor: 'testing' stamp: 'lr 7/25/2011 18:37'!
isActive
	^ (requestor isSelected: target) and: [ target canChangeMode ]! !

!WACmdMode methodsFor: 'testing' stamp: 'lr 7/25/2011 18:37'!
isEnabled
	^ (requestor isSelected: target) and: [ target canChangeMode ]! !

!WACmdMode methodsFor: 'testing' stamp: 'lr 1/20/2009 19:27'!
label
	^ 'Mode'! !

WACmdMode subclass: #WACmdModeDebug
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdModeDebug methodsFor: 'execution' stamp: 'MAD 1/10/2009 18:06'!
execute
	target setDebugMode! !

!WACmdModeDebug methodsFor: 'testing' stamp: 'lr 1/20/2009 19:27'!
label
	^ 'Debug'! !

WACmdMode subclass: #WACmdModeDeployment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdModeDeployment methodsFor: 'execution' stamp: 'MAD 1/10/2009 18:06'!
execute
	target setDeploymentMode! !

!WACmdModeDeployment methodsFor: 'testing' stamp: 'lr 1/20/2009 19:27'!
label
	^ 'Deployment'! !

WACmdMode subclass: #WACmdModeVerbose
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdModeVerbose methodsFor: 'execution' stamp: 'MAD 1/10/2009 18:06'!
execute
	target setVerboseMode! !

!WACmdModeVerbose methodsFor: 'testing' stamp: 'lr 1/20/2009 19:27'!
label
	^ 'Verbose'! !

OBCommand subclass: #WACmdPortForAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdPortForAdaptor methodsFor: 'execution' stamp: 'pmm 12/12/2010 11:19'!
execute
	| port |
	port := OBTextRequest 
		prompt: 'Enter port number'
		template: target adaptor port greaseString.
	(port isNil or: [ port isEmpty or: [ port isAllDigits not ] ]) ifTrue: [ ^ self ].
	target adaptor port: port greaseInteger.
	requestor browser signalRefresh! !

!WACmdPortForAdaptor methodsFor: 'testing' stamp: 'pmm 12/12/2010 11:13'!
isActive
	^ (requestor isSelected: target)
		and: [ target isStopped ]! !

!WACmdPortForAdaptor methodsFor: 'accessing' stamp: 'pmm 12/12/2010 11:11'!
label
	^ 'Port...'! !

OBCommand subclass: #WACmdRemoveAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdRemoveAdaptor methodsFor: 'execution' stamp: 'lr 1/23/2009 08:32'!
execute
	target remove.
	requestor browser announce: (OBNodeDeleted node: target)! !

!WACmdRemoveAdaptor methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:22'!
group
	^ #changing! !

!WACmdRemoveAdaptor methodsFor: 'testing' stamp: 'jf 1/7/2009 21:26'!
isActive
	^ requestor isSelected: target! !

!WACmdRemoveAdaptor methodsFor: 'testing' stamp: 'jf 1/7/2009 21:25'!
isEnabled
	^ (requestor isSelected: target) and: [ target canRemove ]! !

!WACmdRemoveAdaptor methodsFor: 'accessing' stamp: 'jf 1/7/2009 21:28'!
keystroke
	^ $x! !

!WACmdRemoveAdaptor methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:21'!
label
	^ 'Remove adaptor'! !

OBCommand subclass: #WACmdRemoveExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdRemoveExpression methodsFor: 'execution' stamp: 'jf 1/12/2009 12:06'!
execute
	target removeExpression! !

!WACmdRemoveExpression methodsFor: 'testing' stamp: 'jf 1/12/2009 12:04'!
isActive
	^ (requestor isSelected: target) and: [ target isAttribute ]! !

!WACmdRemoveExpression methodsFor: 'testing' stamp: 'jf 1/12/2009 12:05'!
isEnabled
	^ target isOverride! !

!WACmdRemoveExpression methodsFor: 'accessing' stamp: 'jf 1/12/2009 12:04'!
label
	^ 'Clear value'! !

OBCommand subclass: #WACmdRemoveHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdRemoveHandler methodsFor: 'execution' stamp: 'lr 1/20/2009 19:26'!
execute
	target handler parent unregister: target handler.
	requestor browser announce: (OBNodeDeleted node: target)! !

!WACmdRemoveHandler methodsFor: 'testing' stamp: 'lr 1/20/2009 19:26'!
isActive
	^ (requestor isSelected: target) and: [ target isHandler and: [ target handler isRoot not ] ]! !

!WACmdRemoveHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:21'!
keystroke
	^ $x! !

!WACmdRemoveHandler methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:21'!
label
	^ 'Remove'! !

OBCommand subclass: #WACmdStartAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdStartAdaptor methodsFor: 'execution' stamp: 'MAD 1/10/2009 17:08'!
execute
	self isEnabled ifFalse: [ ^ nil ].
	target start.
	requestor browser signalRefresh! !

!WACmdStartAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 16:47'!
isActive
	^ requestor isSelected: target! !

!WACmdStartAdaptor methodsFor: 'testing' stamp: 'lr 9/8/2009 19:44'!
isEnabled
	^ (requestor isSelected: target) and: [ target isServerAdaptor and: [ target canStart ] ]! !

!WACmdStartAdaptor methodsFor: 'accessing' stamp: 'jf 1/10/2009 23:51'!
keystroke
	^ $s! !

!WACmdStartAdaptor methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:28'!
label
	^ 'Start'! !

!WACmdStartAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 16:47'!
wantsButton
	^ true! !

OBCommand subclass: #WACmdStopAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdStopAdaptor methodsFor: 'execution' stamp: 'MAD 1/10/2009 17:07'!
execute
	self isEnabled ifFalse: [ ^ nil ].
	target stop.
	requestor browser signalRefresh! !

!WACmdStopAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 17:06'!
isActive
	^ requestor isSelected: target! !

!WACmdStopAdaptor methodsFor: 'testing' stamp: 'lr 9/8/2009 19:44'!
isEnabled
	^ (requestor isSelected: target) and: [ target isServerAdaptor and: [ target canStop ] ]! !

!WACmdStopAdaptor methodsFor: 'accessing' stamp: 'jf 1/10/2009 23:51'!
keystroke
	^ $s! !

!WACmdStopAdaptor methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:28'!
label
	^ 'Stop'! !

!WACmdStopAdaptor methodsFor: 'testing' stamp: 'MAD 1/10/2009 16:47'!
wantsButton
	^ true! !

OBCommand subclass: #WACmdToggleStreamUploads
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdToggleStreamUploads methodsFor: 'user interface' stamp: 'lr 7/25/2011 19:53'!
addItemToMenu: aMenu
	"Hack. Must nuke the default blankIcon used by OB."

	super addItemToMenu: aMenu.
	self isActive
		ifFalse: [ ^ self ].
	aMenu lastItem icon: nil! !

!WACmdToggleStreamUploads methodsFor: 'execution' stamp: 'pmm 12/12/2010 18:16'!
execute
	target adaptor streamUploads: target adaptor streamUploads not.
	requestor browser signalRefresh! !

!WACmdToggleStreamUploads methodsFor: 'testing' stamp: 'pmm 12/12/2010 18:17'!
isActive
	^ (requestor isSelected: target)
		and: [ target isStopped
		and: [ target canChangeStreamUploads ] ]! !

!WACmdToggleStreamUploads methodsFor: 'accessing' stamp: 'pmm 12/12/2010 18:17'!
label
	^ target isStreamingUploads
		ifTrue: [ '<on>Stream uploads' ]
		ifFalse: [ '<off>Stream uploads' ]! !

OBCommand subclass: #WACmdUseNewDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser-Commands'!

!WACmdUseNewDispatcher methodsFor: 'execution' stamp: 'MAD 2/21/2009 18:56'!
execute
	| dispatcher |
	(OBConfirmationRequest 
		prompt: 'This will replace all applications on this server instance' 
		confirm: 'Proceed')
			ifFalse: [ ^ nil ].
	dispatcher := WADispatcher new.
	target adaptor requestHandler: dispatcher.
	requestor browser announce: (OBNodeCreated node: dispatcher asNode)! !

!WACmdUseNewDispatcher methodsFor: 'testing' stamp: 'MAD 2/21/2009 18:17'!
isActive
	^ requestor isSelected: target! !

!WACmdUseNewDispatcher methodsFor: 'accessing' stamp: 'MAD 2/21/2009 18:54'!
label
	^ 'Use new dispatcher'! !

!GRPackage class methodsFor: '*seaside-tools-omnibrowser' stamp: 'lr 2/17/2010 15:14'!
seasideToolsOmniBrowser
	^ self new
		name: 'Seaside-Tools-OmniBrowser';
		description: 'OmniBrowser based tools to setup and configure server adaptor and dispatchers.';
		addDependency: 'Seaside-Tools-Core';
		url: #seasideUrl;
		yourself! !

OBBrowser subclass: #WAHandlerBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'MAD 2/21/2009 19:50'!
adaptorMetaNode
	| handlers adaptor |
	adaptor := OBMetaNode named: 'adaptor'.
	handlers := self handlerMetaNode.
	adaptor childAt: #requestHandlers labeled: 'handler' put: handlers.
	^ adaptor! !

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'MAD 2/21/2009 19:50'!
defaultMetaNode
	^ self handlerMetaNode! !

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'jf 3/15/2009 18:40'!
defaultRootNode
	^ WAAdmin defaultDispatcher asNode! !

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'lr 8/14/2010 09:17'!
handlerMetaNode
	| attributes handlers |
	handlers := OBMetaNode named: 'handlers'.
	attributes := OBMetaNode named: 'attributes'.
	attributes addFilter: WAAttributeInheritanceFilter new.
	handlers
		childAt: #children labeled: 'Handlers' put: handlers;
		childAt: #groupedAttributes labeled: 'Config' put: attributes;
		addFilter: OBModalFilter new.
	^ handlers! !

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'lr 1/20/2009 19:03'!
optionalButtonPanel
	^ nil! !

!WAHandlerBrowser class methodsFor: 'configuration' stamp: 'jf 1/7/2009 22:46'!
title
	^ 'Request Handler Browser'! !

!WAHandlerBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:18'!
cmdAddHandler
	<command>
	
	^ WACmdAddHandler instances! !

!WAHandlerBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:18'!
cmdRemoveExpression
	<command>
	
	^ WACmdRemoveExpression! !

!WAHandlerBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:18'!
cmdRemoveHandler
	<command>
	
	^ WACmdRemoveHandler! !

!WAHandlerBrowser methodsFor: 'building' stamp: 'lr 1/9/2009 21:52'!
defaultBackgroundColor
	^ Color r: 0.0 g: 0.542 b: 1.0! !

OBBrowser subclass: #WAServerAdaptorBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAServerAdaptorBrowser commentStamp: 'MAD 1/20/2009 00:28' prior: 0!
WAServerAdaptorBrowser is the Seaside Control Panel.

Use it to stop, start, inspect and manage the server instances that are running your Seaside applications. It controls the various types of servers using a standard interface defined by WAServerAdaptor. !

!WAServerAdaptorBrowser class methodsFor: 'configuration' stamp: 'jf 1/7/2009 21:54'!
defaultMetaNode
	| default adaptors |
	default := OBMetaNode named: 'default'.
	adaptors := OBMetaNode named: 'adaptors'.
	adaptors addFilter: WAServerAdaptorStatusFilter new.
	default childAt: #adaptors put: adaptors.
	^ default! !

!WAServerAdaptorBrowser class methodsFor: 'configuration' stamp: 'jf 3/17/2009 15:09'!
defaultRootNode
	^ WAServerManagerNode on: WAAdmin defaultServerManager! !

!WAServerAdaptorBrowser class methodsFor: 'configuration' stamp: 'jf 1/7/2009 20:54'!
paneCount
	^ 1! !

!WAServerAdaptorBrowser class methodsFor: 'configuration' stamp: 'jf 1/7/2009 22:26'!
title
	^ 'Seaside Control Panel'! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:18'!
cmdAddAdaptor
	<command>
	
	^ WACmdAddAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:18'!
cmdBrowseRequestHandler
	<command>
	
	^ WACmdBrowseRequestHandler! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'pmm 12/12/2010 11:16'!
cmdChangeEncoding
	<command>
	
	^ WACmdEncodingForAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'pmm 12/12/2010 11:17'!
cmdChangePort
	<command>
	
	^ WACmdPortForAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdClearConfigurationCaches
	<command>
	
	^ WACmdClearConfigurationCaches! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdClearSessions
	<command>
	
	^ WACmdClearSessions! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdInspectAdaptor
	<command>
	
	^ WACmdInspectAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdModeDebug
	<command>
	
	^ WACmdModeDebug! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdModeDeployment
	<command>
	
	^ WACmdModeDeployment! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdModeVerbose
	<command>
	
	^ WACmdModeVerbose! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdRemoveAdaptor
	<command>
	
	^ WACmdRemoveAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdStartAdaptor
	<command>
	
	^ WACmdStartAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdStopAdaptor
	<command>
	
	^ WACmdStopAdaptor! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'pmm 12/12/2010 18:16'!
cmdToggleStreamUploads
	<command>
	
	^ WACmdToggleStreamUploads! !

!WAServerAdaptorBrowser methodsFor: 'commands' stamp: 'lr 10/29/2010 12:19'!
cmdUseNewDispatcher
	<command>
	
	^ WACmdUseNewDispatcher! !

!WAServerAdaptorBrowser methodsFor: 'building' stamp: 'lr 1/10/2009 22:33'!
defaultBackgroundColor
	^ Color r: 0.212 g: 0.637 b: 1.0! !

!WAServerAdaptorBrowser methodsFor: 'user interface' stamp: 'lr 1/9/2009 21:53'!
initialExtent
	^ 400 @ 300! !

!WAServerAdaptorBrowser methodsFor: 'morphic' stamp: 'lr 11/23/2010 08:38'!
step
	self announce: (OBChildrenChanged node: self root)! !

!WAServerAdaptorBrowser methodsFor: 'morphic' stamp: 'lr 11/23/2010 08:38'!
wantsSteps
	^ true! !

!WAServerAdaptor methodsFor: '*seaside-tools-omnibrowser' stamp: 'lr 1/23/2009 08:32'!
asNode
	^ WAServerAdaptorNode on: self! !

OBDefinition subclass: #WAConfigurationAttributeDefinition
	instanceVariableNames: 'attribute configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAConfigurationAttributeDefinition class methodsFor: 'instance creation' stamp: 'jf 9/17/2008 23:30'!
configuration: aConfiguration attribute: anAttribute
	^ self new
		setConfiguration: aConfiguration attribute: anAttribute;
		yourself! !

!WAConfigurationAttributeDefinition methodsFor: 'updating' stamp: 'jf 9/17/2008 23:31'!
setConfiguration: aConfiguration attribute: anAttribute
	configuration := aConfiguration.
	attribute := anAttribute.! !

!WAConfigurationAttributeDefinition methodsFor: 'callbacks' stamp: 'lr 1/11/2009 23:13'!
text
	^ attribute stringForValue: (configuration at: attribute key)! !

!WAConfigurationAttributeDefinition methodsFor: 'callbacks' stamp: 'jf 9/30/2009 01:10'!
text: aText 
	configuration 
		takeValueFromString: aText greaseString
		forAttribute: attribute.
	^ true! !

!WADispatcher methodsFor: '*seaside-tools-omnibrowser' stamp: 'jf 9/17/2008 22:48'!
asNode
	^ WADispatcherNode on: self! !

!WARequestHandler methodsFor: '*seaside-tools-omnibrowser' stamp: 'jf 9/17/2008 22:48'!
asNode
	^ WAHandlerNode on: self! !

OBNode subclass: #WANode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

WANode subclass: #WAAttributeNode
	instanceVariableNames: 'configuration attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAAttributeNode class methodsFor: 'instance creation' stamp: 'lr 1/11/2009 23:16'!
configuration: aConfiguration attribute: anAttribute
	^ self new setConfiguration: aConfiguration attribute: anAttribute! !

!WAAttributeNode methodsFor: 'accessing' stamp: 'jf 1/12/2009 10:55'!
attribute
	^ attribute! !

!WAAttributeNode methodsFor: 'accessing' stamp: 'jf 1/12/2009 10:55'!
configuration
	^ configuration! !

!WAAttributeNode methodsFor: 'accessing' stamp: 'jf 1/12/2009 11:02'!
default
	^ self attribute default! !

!WAAttributeNode methodsFor: 'public' stamp: 'lr 1/11/2009 23:17'!
definition
	^ WAConfigurationAttributeDefinition configuration: configuration attribute: attribute! !

!WAAttributeNode methodsFor: 'testing' stamp: 'jf 1/12/2009 10:59'!
isAbstract
	"True if the attribute is locally defined and there is no default"
	^ self isLocal and: [ self default isNil ]! !

!WAAttributeNode methodsFor: 'testing' stamp: 'jf 1/12/2009 10:55'!
isAttribute
	^ true! !

!WAAttributeNode methodsFor: 'testing' stamp: 'jf 1/12/2009 11:01'!
isLocal 
	"True if the attribute is defined on this configuration"
	self configuration localAttributeAt: self attribute key ifAbsent: [ ^ false ].
	^ true! !

!WAAttributeNode methodsFor: 'testing' stamp: 'jf 1/12/2009 11:05'!
isOverridden
	^ false! !

!WAAttributeNode methodsFor: 'testing' stamp: 'jf 5/23/2010 22:49'!
isOverride
	"Returns true if there is a value for the attribute on this configuration"
	^ self configuration hasExpressionAt: self attribute key! !

!WAAttributeNode methodsFor: 'public' stamp: 'jf 9/17/2008 23:19'!
name
	^ attribute key! !

!WAAttributeNode methodsFor: 'actions' stamp: 'jf 1/12/2009 12:07'!
removeExpression
	self configuration removeExpressionAt: self attribute key! !

!WAAttributeNode methodsFor: 'initialization' stamp: 'lr 1/11/2009 23:16'!
setConfiguration: aConfiguration attribute: anAttribute
	configuration := aConfiguration.
	attribute := anAttribute! !

WANode subclass: #WAHandlerNode
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

WAHandlerNode subclass: #WADispatcherNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WADispatcherNode methodsFor: 'testing' stamp: 'lr 7/25/2011 19:53'!
canHaveChildren
	^ true! !

!WADispatcherNode methodsFor: 'accessing' stamp: 'lr 8/14/2010 09:18'!
children
	^ (handler handlers collect: [ :each | each asNode ])
		asSortedCollection: [ :a :b | a name < b name ]! !

!WADispatcherNode methodsFor: 'public' stamp: 'jf 1/7/2009 22:48'!
name
	^ super name, '/'! !

!WAHandlerNode class methodsFor: 'instance creation' stamp: 'jf 9/17/2008 22:28'!
on: aRequestHandler
	^ self new setHandler: aRequestHandler; yourself! !

!WAHandlerNode methodsFor: 'accessing' stamp: 'jf 9/23/2009 22:09'!
attributes
	^ handler configuration allAttributes collect: 
		[ :each | 
		WAAttributeNode 
			configuration: handler configuration
			attribute: each ]! !

!WAHandlerNode methodsFor: 'testing' stamp: 'jf 9/17/2008 23:06'!
canHaveChildren
	^ false! !

!WAHandlerNode methodsFor: 'accessing' stamp: 'jf 9/17/2008 22:54'!
children
	^ #()! !

!WAHandlerNode methodsFor: 'accessing' stamp: 'jf 2/15/2010 23:38'!
groupedAttributes
	| groups attributes |
	groups := Dictionary new.
	attributes := OrderedCollection new.
	handler configuration allAttributes do: [ :each |
		(groups
			at: each group
			ifAbsentPut: [ SortedCollection sortBlock: [:a :b | a key <= b key ] ])
				add: each ].
	groups keys sorted do: [ :key |
		(groups at: key) do: [ :each | attributes add: (WAAttributeNode configuration: handler configuration attribute: each) ] ].
	^ attributes! !

!WAHandlerNode methodsFor: 'accessing' stamp: 'lr 1/20/2009 19:17'!
handler
	^ handler! !

!WAHandlerNode methodsFor: 'testing' stamp: 'jf 1/12/2009 10:35'!
isHandler
	^ true! !

!WAHandlerNode methodsFor: 'public' stamp: 'MAD 2/21/2009 19:44'!
name
	^ handler name ifNil: [ '' ]! !

!WAHandlerNode methodsFor: 'accessing' stamp: 'jf 9/17/2008 22:29'!
setHandler: aRequestHandler
	handler := aRequestHandler! !

!WANode methodsFor: 'testing' stamp: 'jf 1/12/2009 10:55'!
isAttribute
	^ false! !

!WANode methodsFor: 'testing' stamp: 'jf 1/12/2009 10:35'!
isHandler
	^ false! !

!WANode methodsFor: 'testing' stamp: 'NickAger 9/4/2009 16:57'!
isServerAdaptor
	^ false! !

WANode subclass: #WAServerAdaptorNode
	instanceVariableNames: 'adaptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAServerAdaptorNode class methodsFor: 'instance creation' stamp: 'jf 1/7/2009 20:41'!
on: aServerAdaptor
	^ self basicNew initializeWithAdaptor: aServerAdaptor; yourself! !

!WAServerAdaptorNode methodsFor: 'accessing' stamp: 'lr 2/7/2009 10:18'!
adaptor
	^ adaptor! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'MAD 1/10/2009 18:21'!
canChangeMode
	^ adaptor respondsTo: #setDebugMode! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'pmm 12/12/2010 11:13'!
canChangeStreamUploads
	^ adaptor respondsTo: #streamUploads! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'jf 1/7/2009 21:24'!
canRemove
	^ adaptor isStopped! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'jf 1/7/2009 21:13'!
canStart
	^ adaptor canStart! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'jf 1/7/2009 21:07'!
canStop
	^ adaptor canStop! !

!WAServerAdaptorNode methodsFor: 'public' stamp: 'pmm 12/12/2010 11:06'!
definition
	^ OBTextDefinition text: (String streamContents: [ :stream |
		stream 
			nextPutAll: 'Type: '; nextPutAll: adaptor class name; nextPut: Character cr;
			nextPutAll: 'Port: '; nextPutAll: adaptor port greaseString; nextPut: Character cr;
			nextPutAll: 'Encoding: '; nextPutAll: adaptor codec name; nextPut: Character cr.
		adaptor additionalStatusOn: stream.
		stream
			nextPutAll: adaptor statusString ])! !

!WAServerAdaptorNode methodsFor: 'initialization' stamp: 'jf 1/7/2009 20:38'!
initializeWithAdaptor: aServerAdaptor
	adaptor := aServerAdaptor! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'MAD 1/10/2009 17:57'!
inspectAdaptor
	adaptor inspect! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'jf 1/7/2009 22:20'!
isRunning
	^ adaptor isRunning! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'NickAger 9/4/2009 17:25'!
isServerAdaptor
	^ true.! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'jf 1/7/2009 22:20'!
isStopped
	^ adaptor isStopped! !

!WAServerAdaptorNode methodsFor: 'testing' stamp: 'pmm 12/12/2010 11:23'!
isStreamingUploads
	^ adaptor streamUploads! !

!WAServerAdaptorNode methodsFor: 'public' stamp: 'pmm 6/26/2011 14:29'!
name
	^ String streamContents: [ :stream |
		stream
			nextPut: $[; print: adaptor port; nextPut: $];
			space;
			nextPutAll: adaptor class name.
		 adaptor class = GRNullCodec ifFalse: [
			stream space; nextPut: $(; nextPutAll:  adaptor codec name; nextPut: $) ] ]! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'jf 1/7/2009 21:25'!
remove
	self canRemove ifTrue: [ adaptor unregister ]! !

!WAServerAdaptorNode methodsFor: 'accessing' stamp: 'jf 1/7/2009 21:22'!
requestHandler
	^ adaptor requestHandler asNode! !

!WAServerAdaptorNode methodsFor: 'accessing' stamp: 'MAD 2/21/2009 19:35'!
requestHandlers
	^ Array with: self requestHandler! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'MAD 1/10/2009 18:05'!
setDebugMode
	adaptor setDebugMode! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'MAD 1/10/2009 18:05'!
setDeploymentMode
	adaptor setDeploymentMode! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'MAD 1/10/2009 18:04'!
setVerboseMode
	adaptor setVerboseMode! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'jf 1/7/2009 21:14'!
start
	self canStart ifTrue: [ adaptor start ]! !

!WAServerAdaptorNode methodsFor: 'updating' stamp: 'jf 1/7/2009 21:14'!
stop
	self canStop ifTrue: [ adaptor stop ]! !

WANode subclass: #WAServerManagerNode
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAServerManagerNode class methodsFor: 'instance creation' stamp: 'jf 1/7/2009 20:41'!
on: aServerManager
	^ self basicNew initializeWithManager: aServerManager; yourself! !

!WAServerManagerNode methodsFor: 'accessing' stamp: 'lr 1/23/2009 08:31'!
adaptors
	^ (manager adaptors asSortedCollection: [ :a :b | a port < b port ]) collect: [ :each | each asNode ]! !

!WAServerManagerNode methodsFor: 'initialization' stamp: 'jf 1/7/2009 20:38'!
initializeWithManager: aServerManager
	manager := aServerManager! !

!WAServerManagerNode methodsFor: 'accessing' stamp: 'lr 11/23/2010 08:41'!
name
	^ 'Server Manager'! !

!WAServerManagerNode methodsFor: 'updating' stamp: 'jf 1/7/2009 21:40'!
startAll
	manager startAll! !

!WAServerManagerNode methodsFor: 'updating' stamp: 'jf 1/7/2009 21:34'!
stopAll
	manager stopAll! !

OBFilter subclass: #WAAttributeInheritanceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAAttributeInheritanceFilter methodsFor: 'filtering' stamp: 'lr 3/5/2009 20:50'!
icon: aSymbol forNode: aNode
	aNode isAttribute
		ifFalse: [ ^ #blank ].
	^ aNode isOverride
		ifTrue: [ 
			aNode isOverridden 
				ifTrue: [ #arrowUpAndDown ] 
				ifFalse: [ #arrowUp ] ]
		ifFalse: [ 
			aNode isOverridden 
				ifTrue: [ #arrowDown ] 
				ifFalse: [ #blank ] ]! !

OBFilter subclass: #WAServerAdaptorStatusFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tools-OmniBrowser'!

!WAServerAdaptorStatusFilter methodsFor: 'filtering' stamp: 'jf 1/7/2009 22:19'!
icon: aSymbol forNode: aNode
	aNode isStopped ifTrue: [ ^ #seasideAdaptorStopped ].
	aNode isRunning ifTrue: [ ^ #seasideAdaptorRunning ].
	^ #blank! !
